//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// emuleDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "emule.h"
#include "emuleDlg.h"
#include "sockets.h"
#include "knownfilelist.h"
#include "knownfile.h"
#include "serverlist.h"
#include "opcodes.h"
#include "sharedfilelist.h"
#include "creditsdlg.h"
#include "ED2KLink.h"
#include "math.h"
#include "Splashscreen.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CemuleDlg Dialog

CemuleDlg::CemuleDlg(CWnd* pParent /*=NULL*/)
	: CTrayDialog(CemuleDlg::IDD, pParent){
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	ready = false;
	lastuprate = 0;
	lastdownrate = 0;
	connicons[0] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_NOTCONNECTED),IMAGE_ICON,16,16,0);
	connicons[1] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_CONNECTED),IMAGE_ICON,16,16,0);
	connicons[2] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_CONNECTEDHIGH),IMAGE_ICON,16,16,0);
	transicons[0] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_UPDOWN),IMAGE_ICON,16,16,0);
	transicons[1] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_UP0DOWN1),IMAGE_ICON,16,16,0);
	transicons[2] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_UP1DOWN0),IMAGE_ICON,16,16,0);
	transicons[3] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_UP1DOWN1),IMAGE_ICON,16,16,0);
	imicons[0] = 0;
	imicons[1] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_MESSAGE),IMAGE_ICON,16,16,0);
	imicons[2] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_MPENDING),IMAGE_ICON,16,16,0);
}

CemuleDlg::~CemuleDlg()
{
	::DestroyIcon(m_hIcon);
	::DestroyIcon(connicons[0]);
	::DestroyIcon(connicons[1]);
	::DestroyIcon(connicons[2]);
	::DestroyIcon(transicons[0]);
	::DestroyIcon(transicons[1]);
	::DestroyIcon(transicons[2]);
	::DestroyIcon(transicons[3]);
	::DestroyIcon(imicons[1]);
	::DestroyIcon(imicons[2]);
}
void CemuleDlg::DoDataExchange(CDataExchange* pDX){
	CTrayDialog::DoDataExchange(pDX);
	
	// Masterbuttons
	DDX_Control(pDX, IDC_BUTTON2, m_btnConnect);
	DDX_Control(pDX, IDC_BN_DOWNLOADS, m_btnDownloads);
	DDX_Control(pDX, IDC_BN_SERVERS, m_btnServers);
	DDX_Control(pDX, IDC_BN_SEARCH, m_btnSearch);
	DDX_Control(pDX, IDC_BN_FILES, m_btnFiles);
	DDX_Control(pDX, IDC_BN_PREFERENCES, m_btnPreferences );
	DDX_Control(pDX, IDC_BN_MESSAGES, m_btnMessages );
	DDX_Control(pDX, IDC_BN_STATISTICS , m_btnStatistics );
}

BEGIN_MESSAGE_MAP(CemuleDlg, CTrayDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)

	ON_BN_CLICKED(IDC_BN_DOWNLOADS , OnBnClicked2)
	ON_BN_CLICKED(IDC_BN_SERVERS , OnBnClicked3)
	ON_BN_CLICKED(IDC_BN_SEARCH , OnBnClicked4)
	ON_BN_CLICKED(IDC_BN_FILES , OnBnClicked5)
	ON_BN_CLICKED(IDC_BN_MESSAGES , OnBnClicked6)
	ON_BN_CLICKED(IDC_BN_STATISTICS, OnBnClicked7)
	ON_BN_CLICKED(IDC_BN_PREFERENCES , OnBnClicked8)

	ON_WM_SIZE()
	ON_MESSAGE(WM_COPYDATA, OnWMData)
	ON_MESSAGE(TM_FINISHEDHASHING,OnFileHashed)
	ON_WM_CLOSE()
	ON_COMMAND(MP_RESTORE, RestoreWindow)
	ON_COMMAND(MP_CONNECT, StartConnection)
	ON_COMMAND(MP_DISCONNECT, CloseConnection)
	ON_COMMAND(MP_EXIT, OnClose )
	ON_WM_CREATE()
END_MESSAGE_MAP()

// CemuleDlg eventhandler

BOOL CemuleDlg::OnInitDialog(){	
	CTrayDialog::OnInitDialog();
	
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL){
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()){
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	sourceTrayIcon= (HICON)LoadImage(AfxGetInstanceHandle() ,MAKEINTRESOURCE(IDR_TRAYICON),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);

	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);

	// Setting up IconButtons
	m_btnConnect.SetIcon(IDI_BN_CONNECT);		m_btnConnect.SetAlign(CButtonST::ST_ALIGN_VERT);
	m_btnDownloads.SetIcon(IDI_BN_DOWNLOAD);	m_btnDownloads.SetAlign(CButtonST::ST_ALIGN_VERT);
	m_btnServers.SetIcon(IDI_BN_SERVER );		m_btnServers.SetAlign(CButtonST::ST_ALIGN_VERT);
	m_btnSearch.SetIcon(IDI_BN_SEARCH);			m_btnSearch.SetAlign(CButtonST::ST_ALIGN_VERT);
	m_btnFiles.SetIcon(IDI_BN_FILES);			m_btnFiles.SetAlign(CButtonST::ST_ALIGN_VERT);
	m_btnStatistics.SetIcon(IDI_BN_STATISTICS);	m_btnStatistics.SetAlign(CButtonST::ST_ALIGN_VERT);

	m_btnMessages.SetIcon(IDI_BN_MESSAGES);		m_btnMessages.SetAlign(CButtonST::ST_ALIGN_VERT);
	m_btnPreferences.SetIcon(IDI_BN_PREFERENCES);m_btnPreferences.SetAlign(CButtonST::ST_ALIGN_VERT);

	//set title
	char buffer[50];
	sprintf(buffer,"eMule V%s",CURRENT_VERSION_LONG);
	SetWindowText(buffer);

	// set statusbar
	statusbar.Create(WS_CHILD|WS_VISIBLE|CCS_BOTTOM,CRect(0,0,0,0), this, IDC_STATUSBAR) ;
	statusbar.EnableToolTips(true);
	CRect rect;
	statusbar.GetClientRect(&rect);
	int widths[5] = { rect.right-430, rect.right-350, rect.right-190,rect.right-25, -1 };
	statusbar.SetParts(5, widths);
	statusbar.SetText("Users: 0",1,0);

	// create dialog pages
	preferenceswnd.Create(IDD_PREFERENCES,theApp.glob_prefs);
	serverwnd.Create(IDD_SERVER);
	transferwnd.Create(IDD_TRANSFER);
	sharedfileswnd.Create(IDD_FILES);
	searchwnd.Create(IDD_SEARCH);
	chatwnd.Create(IDD_CHAT);
	statisticswnd.Create(IDD_STATISTICS);
	activewnd = &transferwnd;

	// set updateintervall of graphic rate display (in seconds)
	ShowConnectionState(false);

	// anchors
	AddAnchor(serverwnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(transferwnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(sharedfileswnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(searchwnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(chatwnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(preferenceswnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(statusbar,BOTTOM_LEFT,BOTTOM_RIGHT);
	AddAnchor(statisticswnd,TOP_LEFT,BOTTOM_RIGHT);

	ShowTransferRate(false);
	statisticswnd.ShowInterval(true);
	// tray icon
	TraySetMinimizeToTray(theApp.glob_prefs->GetMinTrayPTR());

	serverwnd.ShowWindow(SW_SHOW);
	activewnd = &serverwnd;

	theApp.serverlist->Init();
	ready = true;

	// start listining on edonkeyport
	if (!theApp.listensocket->StartListening())
		AddLogLine(false,"Fatal Error: Unable to create socket on port %i",theApp.glob_prefs->GetPort());
	// ini. downloadqueue
	theApp.downloadqueue->Init();

	AddLogLine(true,"eMule Version %s ready",CURRENT_VERSION_LONG);

	if (theApp.pendinglink){
		theApp.downloadqueue->AddSearchToDownload(*theApp.pendinglink);
		delete theApp.pendinglink;
	}

	if (theApp.glob_prefs->DoAutoConnect())
		OnBnClickedButton2();

	// Restore saved window placement
	WINDOWPLACEMENT wp;wp.length=sizeof(wp);
	wp=theApp.glob_prefs->GetEmuleWindowPlacement();
	SetWindowPlacement(&wp);

	// splashscreen
	if (theApp.glob_prefs->UseSplashScreen()){
		CSplashScreen splash(this);
		splash.DoModal();
	}


	return TRUE;
}

void CemuleDlg::OnSysCommand(UINT nID, LPARAM lParam){
	if ((nID & 0xFFF0) == IDM_ABOUTBOX){
		CCreditsDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else{
		CTrayDialog::OnSysCommand(nID, lParam);
	}
}

void CemuleDlg::OnPaint() {
	if (IsIconic()){
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else{
		CTrayDialog::OnPaint();
	}
}


HCURSOR CemuleDlg::OnQueryDragIcon(){
	return static_cast<HCURSOR>(m_hIcon);
}

void CemuleDlg::OnBnClickedButton2(){
  if (!theApp.serverconnect->IsConnected()) 
    //connect if not currently connected
	if (!theApp.serverconnect->IsConnecting()  ) StartConnection(); else {
		theApp.serverconnect->StopConnectionTry();
		ShowConnectionState(false);
	}
  else
    //disconnect if currently connected
    CloseConnection();
}

void CemuleDlg::AddLogLine(bool addtostatusbar,char* line,...){
	va_list argptr;
	char bufferline[500];
	va_start(argptr, line);
	_vsnprintf(bufferline, 500, line, argptr);
	va_end(argptr);
	//(Ornis+)
	char osDate[30],osTime[30]; //<<--9/21/02
	char temp[560]; //<<--9/21/02
	_strtime( osTime ); //<<--9/21/02
	_strdate( osDate ); //<<--9/21/02
	sprintf(temp,"%s %s: %s",osDate,osTime,bufferline);//<<--9/21/02 
	logtext += temp; //<<--9/21/02
	logtext += "\r\n";
	if (ready){
		serverwnd.logbox.SetWindowText(logtext);
		serverwnd.logbox.LineScroll(serverwnd.logbox.GetLineCount());
	if (addtostatusbar)
		statusbar.SetText(bufferline,0,0);
	}

}
void CemuleDlg::AddServerMessageLine(char* line,...){
	CString content;
	va_list argptr;
	char bufferline[500];
	va_start(argptr, line);
	_vsnprintf(bufferline, 500, line, argptr);
	va_end(argptr);
	serverwnd.servermsgbox.AppendText(CString(bufferline)+CString("\n"));
}

void CemuleDlg::ShowConnectionState(bool connected){ShowConnectionState(connected,"");}

void CemuleDlg::ShowConnectionState(bool connected, CString server){
	if (connected){
		
		this->GetDlgItem(IDC_BUTTON2)->SetWindowText("Dis&connect");
		m_btnConnect.SetIcon(IDI_BN_DISCONNECT); m_btnConnect.SetTooltipText("Disconnect from current server");
		
		if (theApp.serverconnect->IsLowID()) 
			statusbar.SetIcon(3,connicons[1]);
		 else 
			statusbar.SetIcon(3,connicons[2]);
		
		statusbar.SetText("Connection established on:"+CString(server),0,0);
		statusbar.SetTipText(3,server);
		statusbar.SetText(server,3,0);
	}
	else{

		if (theApp.serverconnect->IsConnecting()) {
			this->GetDlgItem(IDC_BUTTON2)->SetWindowText("&Cancel");
			m_btnConnect.SetIcon(IDI_BN_STOPCONNECTING);	m_btnConnect.SetTooltipText("Stops the current connection attempts");
			statusbar.SetIcon(3,connicons[0]);
			statusbar.SetText("Connecting",3,0);
			statusbar.SetTipText(3,"");
			ShowUserCount(0);

		} else {
			this->GetDlgItem(IDC_BUTTON2)->SetWindowText("&Connect");
			m_btnConnect.SetIcon(IDI_BN_CONNECT);	m_btnConnect.SetTooltipText("Connect to any server");

			statusbar.SetIcon(3,connicons[0]);
			statusbar.SetText("Not Connected",3,0);
			theApp.emuledlg->AddLogLine(true,"Disconnected");
			statusbar.SetTipText(3,"");
			ShowUserCount(0);
		}

	}
}

void CemuleDlg::ShowUserCount(uint32 toshow){
	char buffer[30];
	sprintf(buffer,"User: %i",toshow);
	statusbar.SetText(buffer,1,0);
}

void CemuleDlg::ShowMessageState(uint8 iconnr){
	statusbar.SetIcon(4,imicons[iconnr]);
}

void CemuleDlg::ShowTransferRate(bool graph){
	char buffer[50];
	char buffer2[100];

	lastuprate = theApp.uploadqueue->GetDatarate();
	lastdownrate= theApp.downloadqueue->GetDatarate();

	if (graph) statisticswnd.SetCurrentRate((float)lastuprate/1024,(float)lastdownrate/1024);

	sprintf(buffer,"Up: %.1f | Down: %.1f",(float)lastuprate/1024,(float)lastdownrate/1024);
	statusbar.SetText(buffer,2,0);

	// set trayicon-icon
	int DownRateProcent=(int)ceil ( (lastdownrate/10.24)/ theApp.glob_prefs->GetMaxGraphDownloadRate());
	if (DownRateProcent>100) DownRateProcent=100;
	UpdateTrayIcon(DownRateProcent);

	if (theApp.serverconnect->IsConnected()) 
		sprintf(buffer2,"eMule (%s | Connected)",buffer);
	else
		sprintf(buffer2,"eMule (%s | Disconnected)",buffer);

	TraySetToolTip(buffer2);

	if (lastuprate && lastdownrate)
		statusbar.SetIcon(2,transicons[3]);
	else if (lastuprate)
		statusbar.SetIcon(2,transicons[2]);
	else if (lastdownrate)
		statusbar.SetIcon(2,transicons[1]);
	else
		statusbar.SetIcon(2,transicons[0]);
}

void CemuleDlg::OnCancel(){

if (*theApp.glob_prefs->GetMinTrayPTR()) {
		TrayShow();
		ShowWindow(SW_HIDE);
	} else {
		ShowWindow(SW_MINIMIZE);
	}

};

void CemuleDlg::SetActiveDialog(CDialog* dlg){
	uint8 sel;
	if (dlg == &transferwnd)
		sel = 0;
	else if (dlg == &serverwnd)
		sel = 1;
	else if (dlg == &searchwnd)
		sel = 2;
	else if (dlg == &sharedfileswnd)
		sel = 3;
	else if (dlg == &preferenceswnd)
		sel = 4;
	else if (dlg == &chatwnd)
		sel = 5;
	else if (dlg == &statisticswnd )
		sel = 6;

	activewnd->ShowWindow(SW_HIDE);
	dlg->ShowWindow(SW_SHOW);
	activewnd = dlg;
}

void CemuleDlg::OnSize(UINT nType,int cx,int cy){
	CTrayDialog::OnSize(nType,cx,cy);
	CRect rect;
	statusbar.GetClientRect(&rect);
	int widths[5] = { rect.right-430, rect.right-350, rect.right-190,rect.right-25, -1 };
	statusbar.SetParts(5, widths);
}

extern void URLDecode(CString& result, const char* buff);

LRESULT CemuleDlg::OnWMData(WPARAM wParam,LPARAM lParam){
	tagCOPYDATASTRUCT* data = (tagCOPYDATASTRUCT*)lParam;
	if (data->dwData == OP_ED2KLINK){
		FlashWindow(true);
		if( theApp.glob_prefs->IsBringToFront() ){
			if (IsIconic())
				ShowWindow(SW_SHOWNORMAL);
			else if (TrayHide()){
				ShowWindow(SW_SHOW);
			}
		else
			SetForegroundWindow();
		}
		try {
			CString link;
			link = (char*)data->lpData;
			URLDecode(link,(const char*)data->lpData);
			CED2KLink* pLink = CED2KLink::CreateLinkFromUrl(link);
			_ASSERT( pLink !=0 );
			switch (pLink->GetKind()) {
			case CED2KLink::kServer:
				{
					CString defName;
					CED2KServerLink* pSrvLink = pLink->GetServerLink();
					_ASSERT( pSrvLink !=0 );
					in_addr host;
					host.S_un.S_addr = pSrvLink->GetIP();
					CServer* pSrv = new CServer(pSrvLink->GetPort(),inet_ntoa(host));
					_ASSERT( pSrv !=0 );
					pSrvLink->GetDefaultName(defName);
					pSrv->SetListName(defName.GetBuffer());
					if (!theApp.emuledlg->serverwnd.serverlistctrl.AddServer(pSrv,true)) 
						delete pSrv;
				}
				break;
			case CED2KLink::kFile:
				{
					CED2KFileLink* pFileLink = pLink->GetFileLink();
					_ASSERT(pFileLink !=0);
					theApp.downloadqueue->AddFileLinkToDownload(pFileLink);
				}
				break;
			default:
				break;
			}
			delete pLink;
		} catch(char* xmsg) {
			AddLogLine(true, "Could not add link");
		}
	}
	return true;
}

LRESULT CemuleDlg::OnFileHashed(WPARAM wParam,LPARAM lParam){
	CKnownFile* result = (CKnownFile*)lParam;
	if (wParam){
		CPartFile* requester = (CPartFile*)wParam;
		requester->PartFileHashFinished(result);
	}
	else{
		theApp.sharedfiles->filelist->SafeAddKFile(result);
		theApp.sharedfiles->SafeAddKFile(result);	
	}
	return true;
}

void CemuleDlg::OnClose()
{
	if (theApp.glob_prefs->IsConfirmExitEnabled() )
		if (IDNO==MessageBox("Do you really want to exit eMule?","Exit confirmation",MB_YESNO)) return;

	// TODO: Add your message handler code here and/or call default
	WINDOWPLACEMENT wp;wp.length=sizeof(wp);GetWindowPlacement(&wp);
	theApp.glob_prefs->SetWindowLayout(wp);

	// saving data & stuff
	theApp.knownfiles->Save();
	for (int i=0;i<9;i++) { 
		theApp.glob_prefs->SetTransferColumnWidth(i, transferwnd.downloadlistctrl.GetColumnWidth(i));
	}
	for (int i=0;i<8;i++) { 
		theApp.glob_prefs->SetServerColumnWidth(i, serverwnd.serverlistctrl.GetColumnWidth(i));
	}

	theApp.glob_prefs->Add2TotalDownloaded(theApp.stat_sessionReceivedBytes);
	theApp.glob_prefs->Add2TotalUploaded(theApp.stat_sessionSentBytes);

	theApp.glob_prefs->Save();

	transferwnd.downloadlistctrl.DeleteAllItems();
	chatwnd.chatselector.DeleteAllItems();
	theApp.clientlist->DeleteAll();
	searchwnd.searchlistctrl.DeleteAllItems();

	delete theApp.listensocket;
	delete theApp.sharedfiles;
	delete theApp.serverconnect;
	delete theApp.serverlist;
	delete theApp.knownfiles;
	delete theApp.searchlist;
	delete theApp.clientcredits;
	delete theApp.downloadqueue;
	delete theApp.uploadqueue;
	delete theApp.clientlist;
	delete theApp.glob_prefs;

	CTrayDialog::OnCancel();
}

void CemuleDlg::OnTrayRButtonDown(CPoint pt){
	trayPopup.CreatePopupMenu(); 

	UINT flagsC;
	UINT flagsD;
	
	// set connect/disconnect to enabled and disabled
	if (!theApp.serverconnect->IsConnected()) {
		flagsD=MF_STRING || MF_DISABLED; flagsC=MF_STRING;
	} else {
		flagsC=MF_STRING || MF_DISABLED; flagsD=MF_STRING;
	}

	trayPopup.AddMenuTitle((CString)"eMule V"+(CString)CURRENT_VERSION_LONG);

	trayPopup.AppendMenu(	MF_STRING ,MP_RESTORE, (LPCTSTR)"Restore"); 
	trayPopup.SetDefaultItem(MP_RESTORE);
	trayPopup.AppendMenu(MF_SEPARATOR);

	trayPopup.AppendMenu(flagsC,MP_CONNECT, (LPCTSTR)"Connect to any server");
	trayPopup.AppendMenu(flagsD ,MP_DISCONNECT,   (LPCTSTR)"Disconnect"); 

	trayPopup.AppendMenu(MF_STRING,MP_EXIT, (LPCTSTR)"Exit"); 

	trayPopup.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, pt.x, pt.y, this); 

	trayPopup.DestroyMenu();

}

void CemuleDlg::StartConnection(){
	AddLogLine(true, "Connecting...");
	theApp.serverconnect->ConnectToAnyServer();
	ShowConnectionState(false);
}

void CemuleDlg::CloseConnection(){
	theApp.serverconnect->Disconnect();
}
void CemuleDlg::RestoreWindow(){
	if (TrayIsVisible()) TrayHide();	
	ShowWindow(SW_SHOW);
}

void CemuleDlg::OnBnClicked2(){ SetActiveDialog(&transferwnd); }
void CemuleDlg::OnBnClicked3(){ SetActiveDialog(&serverwnd);}
void CemuleDlg::OnBnClicked4(){ SetActiveDialog(&searchwnd);}
void CemuleDlg::OnBnClicked5(){ SetActiveDialog(&sharedfileswnd);}
void CemuleDlg::OnBnClicked6(){ SetActiveDialog(&chatwnd);}
void CemuleDlg::OnBnClicked7(){ SetActiveDialog(&statisticswnd);}
void CemuleDlg::OnBnClicked8(){ SetActiveDialog(&preferenceswnd);}

void CemuleDlg::ShowStatistics() {
	statisticswnd.ShowStatistics();	
}

void CemuleDlg::UpdateTrayIcon(int procent)
{
	//HICON mytrayIcon;
	if (mytrayIcon!=NULL) DestroyIcon(mytrayIcon);

	// set the limits of where the bar color changes (low-high)
	int pLimits16[1] = {100};

	// set the corresponding color for each level
	COLORREF pColors16[1] = {RGB(17,121,120)};

	// start it up
 	trayIcon.Init(sourceTrayIcon,100,1,1,16,16,RGB(21,97,110));

	// load our limit and color info
	trayIcon.SetColorLevels(pLimits16,pColors16,1);

	// generate the icon (destroy these icon using DestroyIcon())
	int pVals16[1] = {procent};

	mytrayIcon = trayIcon.Create(pVals16);
	ASSERT (mytrayIcon != NULL);
	if (mytrayIcon)
		TraySetIcon(mytrayIcon);
}

int CemuleDlg::OnCreate(LPCREATESTRUCT lpCreateStruct){
	CTrayDialog::OnCreate(lpCreateStruct);
	/*if (theApp.glob_prefs->UseSplashScreen()){
		ModifyStyleEx(0,WS_EX_LAYERED);
		SetLayeredWindowAttributes(0, 0, LWA_ALPHA);
	}*/
	return 0;

}

